# Class OjLegend

The component WebElement for oj-legend. Do not instantiate this class directly, instead, use ojLegend.

#### Hierarchy

- OjLegendBase
  - OjLegend

#####
Index

### Constructors

constructor

### Methods

changeExpanded
changeHiddenCategories
changeHighlightedCategories
clear
click
findElement
findElements
getAs
getAttribute
getCssValue
getDrilling
getDriver
getExpanded
getHalign
getHiddenCategories
getHideAndShowBehavior
getHighlightedCategories
getHoverBehavior
getHoverBehaviorDelay
getId
getLocation
getOrientation
getProperty
getRect
getScrolling
getSections
getShadowRoot
getSize
getSymbolHeight
getSymbolWidth
getTagName
getText
getTextStyle
getTrackResize
getTranslations
getValign
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjLegend(el, locators): OjLegend

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjLegend

  Inherited from OjLegendBase.constructor

## Methods

### changeExpanded

- changeExpanded(expanded): Promise<void>

- Sets the value of `expanded` property. Specifies the key set containing the ids of sections that should be expanded on initial render. See the Help documentation for more information.

  #### Parameters

  - ##### expanded: null

    The value to set for `expanded`

  #### Returns Promise<void>

  Inherited from OjLegendBase.changeExpanded

### changeHiddenCategories

- changeHiddenCategories(hiddenCategories): Promise<void>

- Sets the value of `hiddenCategories` property. An array of categories that will be hidden.

  #### Parameters

  - ##### hiddenCategories: string[]

    The value to set for `hiddenCategories`

  #### Returns Promise<void>

  Inherited from OjLegendBase.changeHiddenCategories

### changeHighlightedCategories

- changeHighlightedCategories(highlightedCategories): Promise<void>

- Sets the value of `highlightedCategories` property. An array of categories that will be highlighted.

  #### Parameters

  - ##### highlightedCategories: string[]

    The value to set for `highlightedCategories`

  #### Returns Promise<void>

  Inherited from OjLegendBase.changeHighlightedCategories

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjLegendBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjLegendBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjLegendBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjLegendBase.findElements

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the nodeTemplate slot.

  ### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

  Inherited from OjLegendBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjLegendBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjLegendBase.getCssValue

### getDrilling

- getDrilling(): Promise<string>

- Gets the value of `drilling` property. Specifies whether drilling is enabled. Drillable objects will show a pointer cursor on hover and fire an ojDrill event on click. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `drilling` property.

  Inherited from OjLegendBase.getDrilling

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjLegendBase.getDriver

### getExpanded

- getExpanded(): Promise<null>

- Gets the value of `expanded` property. Specifies the key set containing the ids of sections that should be expanded on initial render. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `expanded` property.

  Inherited from OjLegendBase.getExpanded

### getHalign

- getHalign(): Promise<string>

- Gets the value of `halign` property. Defines the horizontal alignment of the legend contents.

  #### Returns Promise<string>

  The value of `halign` property.

  Inherited from OjLegendBase.getHalign

### getHiddenCategories

- getHiddenCategories(): Promise<string[]>

- Gets the value of `hiddenCategories` property. An array of categories that will be hidden.

  #### Returns Promise<string[]>

  The value of `hiddenCategories` property.

  Inherited from OjLegendBase.getHiddenCategories

### getHideAndShowBehavior

- getHideAndShowBehavior(): Promise<string>

- Gets the value of `hideAndShowBehavior` property. Defines whether the legend can be used to initiate hide and show behavior on referenced data items.

  #### Returns Promise<string>

  The value of `hideAndShowBehavior` property.

  Inherited from OjLegendBase.getHideAndShowBehavior

### getHighlightedCategories

- getHighlightedCategories(): Promise<string[]>

- Gets the value of `highlightedCategories` property. An array of categories that will be highlighted.

  #### Returns Promise<string[]>

  The value of `highlightedCategories` property.

  Inherited from OjLegendBase.getHighlightedCategories

### getHoverBehavior

- getHoverBehavior(): Promise<string>

- Gets the value of `hoverBehavior` property. Defines the behavior applied when hovering over a legend item.

  #### Returns Promise<string>

  The value of `hoverBehavior` property.

  Inherited from OjLegendBase.getHoverBehavior

### getHoverBehaviorDelay

- getHoverBehaviorDelay(): Promise<number>

- Gets the value of `hoverBehaviorDelay` property. Specifies initial hover delay in milliseconds for highlighting items in legend.

  ### Deprecated

  Since 14.1.0. This is not recommended in the Redwood design system.

  #### Returns Promise<number>

  The value of `hoverBehaviorDelay` property.

  Inherited from OjLegendBase.getHoverBehaviorDelay

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjLegendBase.getId

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjLegendBase.getLocation

### getOrientation

- getOrientation(): Promise<string>

- Gets the value of `orientation` property. Defines the orientation of the legend, which determines the direction in which the legend items are laid out.

  #### Returns Promise<string>

  The value of `orientation` property.

  Inherited from OjLegendBase.getOrientation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjLegendBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjLegendBase.getRect

### getScrolling

- getScrolling(): Promise<string>

- Gets the value of `scrolling` property. Defines whether scrolling is enabled for the legend.

  ### Deprecated

  Since 12.1.0. Setting scrolling to off is not supported in Redwood theme and it is not recommended. As such, this attribute is deprecated.

  #### Returns Promise<string>

  The value of `scrolling` property.

  Inherited from OjLegendBase.getScrolling

### getSections

- getSections(): Promise<Sections[]>

- Gets the value of `sections` property. An array of objects specifying the legend sections.

  #### Returns Promise<Sections[]>

  The value of `sections` property.

  Inherited from OjLegendBase.getSections

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjLegendBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjLegendBase.getSize

### getSymbolHeight

- getSymbolHeight(): Promise<number>

- Gets the value of `symbolHeight` property. The height of the legend symbol in pixels. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `symbolHeight` property.

  Inherited from OjLegendBase.getSymbolHeight

### getSymbolWidth

- getSymbolWidth(): Promise<number>

- Gets the value of `symbolWidth` property. The width of the legend symbol in pixels. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `symbolWidth` property.

  Inherited from OjLegendBase.getSymbolWidth

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjLegendBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjLegendBase.getText

### getTextStyle

- getTextStyle(): Promise<object>

- Gets the value of `textStyle` property. The CSS style object defining the style of the legend item text.

  #### Returns Promise<object>

  The value of `textStyle` property.

  Inherited from OjLegendBase.getTextStyle

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  ### Deprecated

  Since 15.0.0. With the track resize optimized, this API is no longer required. track-resize on will be the default behavior.

  #### Returns Promise<string>

  The value of `trackResize` property.

  Inherited from OjLegendBase.getTrackResize

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjLegendBase.getTranslations

### getValign

- getValign(): Promise<string>

- Gets the value of `valign` property. Defines the vertical alignment of the legend contents.

  #### Returns Promise<string>

  The value of `valign` property.

  Inherited from OjLegendBase.getValign

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjLegendBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjLegendBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjLegendBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjLegendBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjLegendBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjLegendBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjLegendBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjLegendBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjLegendBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjLegendBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjLegendBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjLegendBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjLegendBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjLegendBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjLegendBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjLegendBase.isId

Generated using TypeDoc